#include    <math.h>
#include    <stdlib.h>
#include    <stdio.h>
#include    <string.h>


void printversion(){//VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION 
    printf("IINC version S20180423.\n");
}
//VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION VERSION 

//Changes 23.04.2018
//	reduced to the iinc method only. Deleted SEL and REG parameters and very simplified usage.
//changes 11.10.2017
//	split into header file iinc.cpp (iinc.h) and main program riinc.cpp
//	THIS IS HEADER FILE iinc.cpp.
//changes 6.10.2017
//	some comments and explanations included into text and also into iinc help.
//changes 17.8.2017
//	in procedure iincmain corrected error in the part of normalization
//	added metrics -16 Huhu = multiplicative distance
//	-17 Ha2 squared
//	in sort procedure changed criterion for switch of items sorted [possible return to the quicksort].
//changes 9.8.2017
//	Added RUM (Reduced Learning set) parameter for rapid, nearly instant learning.
//changes 7.8.2017
//	starting to add the contingency table CT that is appended to file CT.txt
//changes 19.8.2016
//      removed  LinRegre2() - now as weighted linear regression in MyFu.cpp together with Huber's and tucker's robust regression.
/*changes 11/06/2016
	introduced Huber's andTucker's robust regression
//changes 17/06/2016
	REG=2 deleted (works bad in any case)
//changes 04/05/2016  NOTE: check control with the use of ctrl file on line 1068.
	DME=4 does not work properly; not in help now.
 	Reorganized for root (CERN): star notation instead of brackets in formal parameters of functions.
	qsort (caused segmentaion fault) -> bubble sort instead.
	ctrl file allows to stop run in excessively long runs without loss of results obtained in meanwhile.
//changes 9/04/2016
	Five metrics added.
	For three metrics (Clark, Canberra, and Hassanat) no normalization is performed.
//changes 10/03/2016
	Do not sort distances for global method (DME=3).
//changes 24/02/2016
	Correction when printing report on the number of lebels in the testing file" if no labels, "no labels" is reported.
//changes 18/02.2016
	SEL=1 included (the whole learning set, but classes separately. Not q=2.q )
//changes 02/02/2016>
	Hyperbolic regression uses all data as the upper margin now. The bottom margin is given by SEL variable.
	See M. Jirina and M. Jirina, Jr.: Correlation dimension/based classifier. Technical report No. V-945, 
	Institute of Computer Science AS CR, Czech republic.
//changes 01/2016>
	Introduced computation of the DME for local and global methods with the use of
	Fibonacci section method minimizing sagginess in Count=f(r^q) coordinates.
//Changes 11/2015>
	Metric and distace procedure moved to MyFu.cpp (.h).
//Changes 08/2015>
	Crossing included if desired; variable long Cross.
//Changes 02/2014:
	Mahalanobis distance included.
	Changed way of method and its parameters control; 
		DME and SEL parameters slightly modified, 
		WEI parameter discarded.
	Corrected error appearing when test data without class were used as testing set.
	Distances are now computed by universal separate function and corresponding places call this function.
*/


void printmat(double* A, long dim){
	long i,j;
	for(i=0;i<10;i++){
		for(j=0;j<dim;j++) printf("%10lg  ",A[i*dim+j]);
		printf("\n");
	}
}


void IINC(double *LearnArra, double *OutArra, TDist *Dist, long Dimension, long classes, long kk, 
		 long *Count, double *S, long LearnSamples, double *weit,
		 long minCount){
	//kk=test sample index ... with weights
	long i, k;
	double sum, trida;
	for(i=0;i<classes;i++) S[i]=0; 
	for(i=0;i<LearnSamples;i++) {//summing up reciprocals according to classes
		k=Dist[i].I;//index of the i-th nearest neighbor
		trida=LearnArra[k*(Dimension+1)+Dimension];//its class
		S[(long)(0.001+trida)]+=weit[k]/((double)(i+1));  //=1/((double)(i+1));
	}
	sum=0;
	for(i=0;i<classes;i++) {
		OutArra[kk*classes+i]=(double)S[i]/Count[i];
		sum+=OutArra[kk*classes+i];
	}
	for(i=0;i<classes;i++) OutArra[kk*classes+i]=OutArra[kk*classes+i]/sum;
}



//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long iincbase(double *LearnArr, double *TestArr, double *OutArr, long Dimension, 
	long classes,long LearnSamples,long TestSamples, long TAResp, 
	double Metric, long Repeated, long *Count, double *weit, 
	char *Message) {
//The main function that performs all computations.

//returns 0 if OK.

//BASIC PARAMS:
//LearnArr[LearnSamples][Dimension+1] //the learning array  //C++ uklada po radcich!!!
//                      will be overriden by normalized variables!
//TestArr[TestSamples][Dimension+TAResp] .. the array of testing samples
//OutArr[TestSamples] .. vector of responses to samples of the TesArr in the same order
//Dimension .. the number of independent variables
//classes  .. true number of classes; maximum 100.
//LearnSamples .. the number of learning samples (rows of the matrix)
//TestSamples .. the number of testing samples
//TAResp .. either 0 if the TestArr does not include the desired responses
//                      or 1 if the structure if the TestArr is the same as of the LearnArr
//Count[100] .. an array of numbers of samples of individual classes in the LearnArray 
//   without respect to ordering in the LearnArr

//CONTROL PARAMS - see iinc help.
//note: WEI = REG
//Message is any text.
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long i, j, kk, trida, minCount;
double dist2, CDimense;
double*  S     = new double  [classes];//the working array of partial sums for individual classes
TDist* Dist  = new TDist [LearnSamples];//array of distances and indexes to array of the learning set
TDist Distx;
char st[50000];
CDimense=0;
i=1;
j=1;
if((long)(Metric-0.001)==-1 || (long)(Metric-0.001)==-2) i=Dimension;
if((long)(Metric-0.001)==-2) j=classes;
double* CovMat = new double [j*i*i];//the covariance matrix array for Mahalanobis
double* ZZ = new double [j*i*i];    //the ZZ decomposition of covariance matrix for Mahalanobis
double* DD = new double [j*i*i];    //the matrix of squares of eigenvalues of covariance matrix for Mahalanobis
i=1;
if(Metric==-2) i=classes;
double* MeansDev = new double [i*3*Dimension];
	//layers according to label, i.e. Class, then: 
	//row[0*Vstupu+...] means of features
	//row[1*Vstupu+...] sigmas of features
	//row[2*Vstupu+...] the query point normalized
FILE *hh;

//compute normalization constants  //initialize
if(Repeated!=1)  //including Class Dependent Mahalanobis 
	normalize(LearnArr, Dimension, LearnSamples, Count, classes, MeansDev, Metric);
else { //fill-in MeansDev so that no normalization is made
	for(i=0;i<Dimension;i++){
		MeansDev[0*Dimension+i]=0;//means
		MeansDev[1*Dimension+i]=1;//sigmas
			//MeansDev[2*Dimension+i]=1;//query point normalizad
	}
}

if((long)(Metric-0.001)==-1){// for Mahalanobis independent of class
	//void CovarMatrix(double LearnArr[], long Dimension, long LearnSamples, long Class, double CovMat[]) {
	CovarMatrix(LearnArr, Dimension, LearnSamples, -1, CovMat, Count);
	//void ainvl(double z[],double d[],double a[],long n,double tol);
	ainvl(ZZ,DD,CovMat,Dimension,0.000001);
}

if((long)(Metric-0.001)==-2){// for Mahalanobis CDM
	//void CovarMatrix(double LearnArr[], long Dimension, long LearnSamples, long Class, double CovMat[]) {
	for(i=0;i<classes;i++){
		CovarMatrix(LearnArr, Dimension, LearnSamples, i, CovMat, Count);//&CovMat[i*Dimension*Dimension]
		ainvl(&ZZ[i*Dimension*Dimension],DD,CovMat,Dimension,0.000001);
	}
}

//compute distances from the testing sample
for(kk=0;kk<TestSamples;kk++){//loop over all testing samples
	st[0]=32;
	if ((hh = fopen("ctrl", "rt")) != NULL) {
		fscanf(hh,"%[^\n]\n", st);//precten cely radek jako retezec
		if((st[0]==115) || (st[0]==83)){
			fclose(hh);
			goto loopbreak;
		}
	}

	printf(" %li",kk+1);//dizpet(6);
	for(j=0;j<Dimension;j++) MeansDev[2*Dimension+j]=(TestArr[kk*(Dimension+TAResp)+j]
		-MeansDev[0*Dimension+j])/MeansDev[1*Dimension+j]; //recompute to zero mean and unit sigma
	//initialization of Dist array
	for(i=0;i<LearnSamples;i++) {
		Dist[i].D=1.0e33; //inicialization of the distance
		Dist[i].I=i;      //original indices
	};
	//samples one after another
	for(i=0;i<LearnSamples;i++){  //compute distances
		trida=(long)(0.001+LearnArr[i*(Dimension+1)+Dimension]);
		dist2= distance(&LearnArr[i*(Dimension+1)], &MeansDev[2*Dimension], ZZ, 
			Dimension, Metric, trida); 
		if(dist2 < (double)0) {
			printf("Distance=%lg is invalid in Metric=%lg. \n",dist2,Metric);
			return 9;
		}
			//set into the Dist array and also the class mark
		trida=(long)(0.001+LearnArr[i*(Dimension+1)+Dimension]);
		if (dist2<1.0e-10) goto hned;
		Dist[i].D=dist2; //Write to array Dist // true distances in a given Metric
	}// end of loop of learning samples for a given testing sample
	//QUICK SORT to arrange the distances in ascending order (not for global) \n"
		//qsort(Dist, LearnSamples, sizeof(TDist), TDistCompare);
	for(j=0;j<LearnSamples;j++) {
		for(i=0;i<LearnSamples-1;i++){
			if(Dist[i].D > Dist[i+1].D){ 
				Distx.D=Dist[i].D;
				Dist[i].D=Dist[i+1].D;
				Dist[i+1].D=Distx.D;
				Distx.I=Dist[i].I;
				Dist[i].I=Dist[i+1].I;
				Dist[i+1].I=Distx.I;
			}
		}
	}
	// Thus there are neighbors in array Dist[][trida] arranged according the distances in ascending order for each class.
	//END of CORE part sorting
	//CORE part TWO - compute probability estimations for ALL classes for kk=th sample://TTT
//for(j=0;j<20;j++) printf("1059: %lg\n",Dist[j].D);
//getchar();

	//IINC method ... with weights
	minCount=0;
	IINC(LearnArr, OutArr, Dist, Dimension, classes, kk, Count, S, LearnSamples, weit,
		minCount);
//void IINC(double LearnArr[], double OutArr[], TDist Dist[], long Dimension, long classes, long kk, 
//		 long Count[], double S[], long LearnSamples, double weit[],
//		 long minCount){

	//CORE end; in OutArr are probabilities of sample belonging to a classs
hned:;
	howfarWhat(TestSamples, kk, Message);
}//end of loop over testing samples
printf("\n");
loopbreak:;
delete MeansDev;
delete DD;
delete ZZ;
delete CovMat;
delete Dist;
delete S;
return 0;
} /*END of iincbase(LearnArr, TestArr, OutArr, Dimension, 
	classes, LearnSamples, TestSamples, TAResp, 
	Metric, Repeat, DME, SEL, REG, AdHoc, Count, weit, 
	Cross, Message, OUTL);*/


//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
void iincmain(char *SouborSite, char *TestFile, long FileType, long Vstupu, 
	double Metric, long Repeat, char *SWEI, long sweic, 
	char *txt2, char *argv0, long RUM) {
// The main function of the IINC system that reads files and is controlled by parameters that must be known already,
// see help for details.
// In fact, this functions reads files to arrays, then calls iincbase function, writes *.res file and appends a row to register.res file.
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long i, j, k, m, labels, CountErr[20], Count[100], RadkuTST, MaxClasses;
char  *ptr, c = '.', text[255];
double a[10010];
long RadkuSite, result, DME1, TAResp;
printf("\nIINC start. ");
MaxClasses=100;

if(strcmp(SWEI,"1")==0){ //weighted case, derive name of file of sample weights
	ptr = strrchr(SouborSite, c);
	if (ptr-SouborSite>0){
		if (ptr) MYstrncpy(SWEI,SouborSite,ptr-SouborSite);
		else MYstrncpy(SWEI,SouborSite,strlen(SouborSite));
	}
	else {strcpy(SWEI,"s");SWEI[1]=(char)NULL;}
	strcat(SWEI,".wei");
}
strcpy(text,txt2);
//text[strlen(text)]=(char)NULL;
strcpy(text, "IINC (1/i) method"); text[17]=(char)NULL;DME1=0;

if(strcmp(SWEI,"0")!=0) strcat(text, " sample weighted");

//here state the number of inputs:
if(FileType==2){
	if(Vstupu==-1){
		printf("Input error: You have to state the dimension using DIM=... named parameter when using FileType=2.\n");
		exit(1);
	}
}
else {
	FILE *ff;
	if ((ff = fopen(SouborSite, "rt")) == NULL){
			fprintf(stderr, "Procedure CountFile: Cannot open file to read %s.\n", SouborSite);
			exit(1);
	}
	Vstupu=CtiRadek(ff, a)-1;//-1 for class label, works also for string class labels.
	fclose(ff);
}
//here state whether the test file has class labels:
FILE *ff;
if ((ff = fopen(TestFile, "rt")) == NULL){
	fprintf(stderr, "Procedure CountFile: Cannot open file to read %s.\n", TestFile);
	exit(1);
}
TAResp=CtiRadek(ff, a)-Vstupu;//=1 for class label, works also for string class labels.
fclose(ff);


printf("\n%s: NNfile:%s TestFile:%s SWEI=%s sweic=%li NoOfInputs:%li FileType:%li ", 
	text, SouborSite, TestFile, SWEI, sweic, Vstupu, FileType);
char* labList = new char [20*MaxClasses];
//count no of samples of all classes and fill-in the NN array,
labels=0;
CountFile(SouborSite, FileType, Vstupu, labels, labList, RadkuSite, a, MaxClasses, 1);
printf("RadkuSite=%li  Labels=%li\n",RadkuSite, labels);
double* NN = new double [RadkuSite*(Vstupu+1)];
for(i=0;i<labels;i++)   Count[i]=0; //zeros to samples counts
ReadFile(SouborSite, FileType, Vstupu, labels, labList, RadkuSite, a, NN, Count, 1);
// tim je nactena LearnArr do pole NN[].

// reduce the learn set to RUM randomly selected samples for each class (no weights is supposed)
for(i=0;i<labels;i++) if(RUM>Count[i]) RUM=Count[i];//RUM must not be greater then the smallest class
if(RUM>0 && RUM*labels<RadkuSite) {
	double* NN2 = new double [RUM*labels*(Vstupu+1)];
	for(k=0;k<labels;k++){
		for(i=0;i<RUM;i++){
			do {//randonly select a sample and state its class
				j=(long)RadkuSite*(double)rand()/RAND_MAX;			
				m=(long)NN[j*(Vstupu+1)+Vstupu];
//printf("k i j m: %li %li %li %li\n",k,i,j,m);
			}	
			while(m!=k);// i.e. if trida == class continue
			for(m=0;m<Vstupu+1;m++) {
				NN2[((k*RUM+i)*(Vstupu+1)+m)]=NN[j*(Vstupu+1)+m]; 
//				printf("%1lg  ",NN2[(k*RUM+i)*(Vstupu+1)+m]);
			}
//printf("\n");//getchar();
		}
	}
	printf("Reduced learning set to %li samples/class, %li classes, %li inputs.\n",
		RUM,labels,Vstupu);
	RadkuSite=RUM*labels;	
	for(j=0;j<RadkuSite;j++){ 
		for(i=0;i<Vstupu+1;i++) {
			NN[j*(Vstupu+1)+i]=NN2[j*(Vstupu+1)+i]; 
		}
	}
}
/*	printf("\nRUM test prints\n");
	for(i=0;i<RadkuSite;i++){ 
		for(j=0;j<Vstupu+1;j++) 
			printf("%1lg  ",NN[i*(Vstupu+1)+j]); 
		printf("\n\n");
	}
	getchar();
*/
//else nothing
//END of part RUM


//reading file of weights if any
double* weit = new double [RadkuSite];
FILE *ww;
if(strcmp(SWEI,"0")!=0) {
	if ((ww = fopen(SWEI, "rt")) == NULL){
		fprintf(stderr, "Cannot open file to read %s.\n", SWEI);
		exit(1);
	}
	for(k=0;k<RadkuSite;k++){
		j=CtiRadek(ww,a);
		if(j<sweic) weit[k]=1;
		else weit[k]=fabs(a[sweic-1]);
	}
	fclose(ww);//end of reading weights
}
else for(k=0;k<RadkuSite;k++) weit[k]=1;
//read file of testing data
CountFile(TestFile, FileType, Vstupu, labels, labList, RadkuTST, a, MaxClasses, TAResp);
double* TST = new double [RadkuTST*(Vstupu+1)];
double* Probab = new double [RadkuTST*labels];
ReadFile (TestFile, FileType, Vstupu, labels, labList, RadkuTST, a, TST, Count, TAResp); // tim je nacten test. soubor
if(TAResp==1) printf("RadkuTST=%li  Labels=%li\n",RadkuTST, labels);
else          printf("RadkuTST=%li  no labels\n",RadkuTST);


/*otisk
long ii, jj, ss;
ss=0;
for(ii=0+ss;ii<10+ss;ii++){
	for(jj=0;jj<=Vstupu; jj++) printf("%10lg  ",NN[ii*(Vstupu+1)+jj]);
	printf("\n");
}
printf("Hit ENTER to continue\n");
getchar();

for(ii=0+ss;ii<10+ss;ii++){
	for(jj=0;jj<=Vstupu; jj++) printf("%10lg  ",TST[ii*(Vstupu+1)+jj]);
	printf("\n");
}
printf("Hit ENTER to continue\n");
getchar();
*/


Repeat=0;//standard case, all is normalized before computation
if(  //for some metrics no normalization is needed:	
//printf("  if Metric: >= 1; Lp metric.\n");
//printf("  if Metric: = -1; Mahalanobis metric derived from the whole learning set)\n");
//printf("  if Metric: = -2; Mahalanobis class dependent metric.\n");
//printf("  if Metric: = -3; Orloci metric.\n");
//printf("  if Metric: = -4; Angular semimetric.\n");
	Metric == -5 // Clark metric.\n");
//printf("  if Metric: = -6; Lorentz metric.\n");
	|| Metric == -7 // Canberra metric.\n");
//printf("  if Metric: = -8; Bray-Curtis (nearly) metric.\n");
//printf("  if Metric: = -9; Intersection (nearly) metric.\n");
//printf("  if Metric: =-10; Cayley-Klein-Hilbert metric.\n");
//printf("  if Metric: =-11; Weierstrass metric.\n");
//	|| Metric == -12 //Hassanat metric.\n");
//printf("  if Metric: =-21; Pearson (nearly) metric.\n");
//printf("  if Metric: =-22; Jacknife (nearly) metric.\n");
//printf("  if Metric: =-23; Goodman-Kruskal (nearly) metric.\n");
//printf("  if Metric: =-24; Kendall metric.\n");
//printf("  if Metric: =-25; Spearman metric.\n");
  ) Repeat=1;
/**/
//printf("in:iincbase  Vstupu%li, labels%li, RadkuSite%li, RadkuTST%li, Metric%lg, Repeat%li, DME%lg, SEL%li, REG%li, AdHoc%lg\n",
//                     Vstupu, labels, RadkuSite, RadkuTST, 
//	Metric, Repeat, DME, SEL, REG, AdHoc);
//getchar();
result=iincbase(NN, TST, Probab, Vstupu, labels, RadkuSite, RadkuTST, 1, 
	Metric, Repeat, Count, weit,
	SouborSite) ;//SouborSite, i.i. message
if(result>0) goto kon;
//Evaluate and write *.res file
EvalWri(argv0, SouborSite, TestFile, FileType, labels, Vstupu, TST, RadkuTST, CountErr, Probab, 
	labList, text, 0, 0, Metric);
//Write to registering file
for(i=1;i<16;i++) CountErr[i]=0;
regist(argv0, SouborSite , TestFile, RadkuTST, labels, CountErr, Metric, text);
kon:;
printf("\nIINC ready.\n");
} // END of iincmain(SouborSite,....)




//FUNCTIONS TO CALL - WITH DATA IN TEXT FILES **********************************************
/*void iincmain(char SouborSite[], char TestFile[], long FileType, long Vstupu, 
	double Metric, long Repeat, double DME, long SEL,
	long REG, char SWEI[], long sweic, 
	long Cross, char txt2[], long OUTL, double AdHoc, char argv0[], long RUM) {
*/

//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
void iincmain3p(char *SouborSite, char *TestFile, 
	double Metric) {
// The main function of the IINC system that reads files and is controlled by other four parameters that must be known already,
// The FileType=2 is not supposed. For details see iinc help.
// In fact, this function calls iincmain function with some parameters constant.
//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
char d[255],dd[255],ddd[255];
iincmain(SouborSite, TestFile, 1, 0, 
	Metric, 0, strcpy(ddd,"0"), 1, 
	strcpy(d,"IINC with controlled Metric"), strcpy(dd,"iinc3p"),0);
}

//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
void iincmain2p(char *SouborSite, char *TestFile) {
// The main function of the IINC system that needs files names only,
// The FileType=2 is not supposed; see help for details.
// In fact, this functions reads files to arrays, then calls iincbase function, writes *.res file and appends a row to register.res file.
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
//printf("iincmain2p\n");
char d[255],dd[255],ddd[255];
iincmain(SouborSite, TestFile, 1, 0, 
	-12, 0, strcpy(d,"0"), 1, 
	strcpy(dd,"iinc method 2 par (Hass metric)"), strcpy(ddd,"iinc2p"),0);
}


//FUNCTIONS TO CALL - WITH DATA IN double ARRAYS ********************************************
/*long iincbase(double *LearnArr, double *TestArr, double *OutArr, long Dimension, 
	long classes,long LearnSamples,long TestSamples, long TAResp, 
	double Metric, long Repeated, double DME, long SEL, 
	long WEI, double AdHoc, long *Count, double *weit, 
	long Cross, char *Message, long OUTL) {
//returns 0 if OK.*/
//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long iincbase11(double *LearnArr, double *TestArr, double *OutArr, long Dimension, 
	long LearnSamples,long TestSamples, long TAResp, 
	double Metric, long *Count, double *weit, char *Message) {
//The main function that performs all computations with # of parameters reduced to 14.
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long i;
i = iincbase(LearnArr, TestArr, OutArr, Dimension, 
	2, LearnSamples, TestSamples, TAResp, 
	Metric, 0, Count, weit, Message);
return i;
}
//returns 0 if OK.

//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long iincbase9(double *LearnArr, double *TestArr, double *OutArr, long Dimension, 
	long LearnSamples, long TestSamples, long TAResp, 
	long *Count, double *weit) {
//The main function that performs all computations with # of parameters reduced to 9.
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
long i;
char d[255];
i = iincbase(LearnArr, TestArr, OutArr, Dimension, 
	2, LearnSamples, TestSamples, TAResp, 
	-12, 0, Count, weit, strcpy(d,"iinc"));
return i;
}
//returns 0 if OK.



void commonhelp(){
printf("\nNamed parameters: Form: ParName=Parvalue\n");
printf("FileType: a type of NN and Test files. Default=0\n");
printf("  =0 Reading lines as numbers including ClassMark.\n");
printf("  =1 Reading NoOfInputs numbers and Class string.\n");
printf("  =2 Reading pairs (index of word, word count) until (-1 -1) then Class string.\n");
printf("     In this case state the dimension using named parameter DIM=...\n");

printf("SWEI: the name of the file of sample weights, eventually inluding the path.\n"); 
printf("  if SWEI=1 then the file of sample weights LearningFile.wei is searched.\n");
printf("  Default SWEI=0, i.e. no sample weights are present.\n");
printf("  Weights should be positive only; else absolute values are used.\n");
printf("  The file of weights must have the same number of rows as the learning file\n");
printf("  If the file of weights does not have the same number of rows as\n");
printf("  the LearninfFile error message appears and program stops.\n");
printf("sweic: the column number in the file of samples weights.\n");
printf("  default 1. If the item does not exist the weight is set to 1.\n");
printf("Hit ENTER to continue.");
getchar();
printf("Metric; default: Metric=2. Used also if invalid number for Metric is given.\n");
printf("  if Metric: >= 1; Lp metric.\n");
printf("  if Metric: = -1; Mahalanobis metric derived from the whole learning set)\n");
printf("  if Metric: = -2; Mahalanobis class dependent metric.\n");
printf("  if Metric: = -3; Orloci metric.\n");
printf("  if Metric: = -4; Angular semimetric.\n");
printf("  if Metric: = -5; Clark metric.\n");
printf("  if Metric: = -6; Lorentz metric.\n");
printf("  if Metric: = -7; Canberra metric.\n");
printf("  if Metric: = -8; Bray-Curtis (nearly) metric.\n");
printf("  if Metric: = -9; Intersection (nearly) metric.\n");
printf("  if Metric: =-10; Cayley-Klein-Hilbert metric.\n");
printf("  if Metric: =-11; Weierstrass metric.\n");
printf("  if Metric: =-12; Hassanat metric.\n");
printf("  if Metric: =-15; H2 metric.\n");
printf("  if Metric: =-16; Product semimetric (H3,Huhu).\n");
printf("  if Metric: =-17; Polynomial distance semimetric (Ha22).\n");
printf("  if Metric: =-21; Pearson (nearly) metric.\n");
printf("  if Metric: =-22; Jacknife (nearly) metric.\n");
printf("  if Metric: =-23; Goodman-Kruskal (nearly) metric.\n");
printf("  if Metric: =-24; Kendall metric.\n");

printf("Repeat: if equal to 1 then do not use normalization; default 0.\n");
printf("txt2: any text.\n");
printf("argv0: any text, but preferable the name of the program (argv[0]).\n");
printf("RUM: reduce the learning set to RUM randomly selected samples for each class (no weights is supposed)\n");
printf("  RUM must not be greater then the number of samples of the smallest class.\n");
printf("AdHoc: a constant for fine tuning in some cases. Default 1.\n");
//getchar();        

printf("\nFile of results: filename = TestFile.res:\n");
printf("  The first row: lrn file name, tst file name, No. of inputs, ValueOfClass1\n");
printf("  Other rows each:\n");
printf("    Input values (their number according to No. of inputs),\n");
printf("    class if given else 0, class found, probabilities of classes, sample No.\n");

printf("\nAdditional text files generated:\n");
printf("  register.txt:\n");
printf("    One row is appended for each task and consists of task desription,\n");
printf("    number of testing samples and no. of errors.\n");
printf("  howfar.txt:\n");
printf("    Shows percentage of samples already processed.\n");
printf("    (good for very large data sets.)\n");
printf("\nA long run of the program can be interrupted without loss of results computed\n");
printf("  meanwhile with the use of text file ""ctrl"" with first character ""s"" or ""S"".\n");
}

void iinchelp(){
printf("\nIINC help.\n");
printversion();
printf("LearningFile: each row: inputs ClassMark\n");
printf("  No other data is supposed on the line.\n");
printf("  Max. 100 classes is supposed.\n");
printf("  Task dimension DIM and the LearningFile size are limited by the size of\n");
printf("  alloctable memory only.\n");
printf("TestFile: each row: inputs [ClassMark]\n");
printf("  Only DIM or DIM+1 items are read from the line.\n");
commonhelp();
}

void iincbasehelp(){
printf("\nIINC base help\n");//no version here!!
printversion();
printf("A function with parameters as follow\n");
printf("LearnArr: a one-dimensional double array with rows (ie. events) one after another where\n");
printf("  each row contains: variables and Label, i.e. ClassMark (i.e. 1 for signal, 2 for background sample.\n");
printf("  No other data is supposed on the line.\n");
printf("  Task dimension DIM and the LearningFile size are limited by the size of\n");
printf("  alloctable memory only.\n");
printf("TestArr: each row: inputs [Label, i.e. ClassMark]\n");
commonhelp();
}

/*KONEC ======================================================*/
